#!/usr/bin/env bash

# Credit to @coolaj86 and Ryan Burnett: https://github.com/bnnanet/learn-colocation/issues/7
# This will need to be updated next time Debian upgrades because it specifies bookworm.

echo "Adding the pve-no-subscription package lists for bookworm to /etc/apt/sources.list.d/ before updating"

sed -i 's:^deb :#deb :g' /etc/apt/sources.list.d/pve-enterprise.list
sed -i 's:^deb :#deb :g' /etc/apt/sources.list.d/ceph.list

wget http://download.proxmox.com/debian/proxmox-release-bookworm.gpg -O /etc/apt/trusted.gpg.d/proxmox-release-bookworm.gpg

echo '# pve-no-subscription repository provided by proxmox.com, not recommended for production use
deb http://download.proxmox.com/debian/pve bookworm pve-no-subscription' > /etc/apt/sources.list.d/pve-no-subscription.list

echo '# ceph no-subscription repository provided by proxmox.com, not recommended for production use
deb http://download.proxmox.com/debian/ceph-quincy bookworm no-subscription' > /etc/apt/sources.list.d/ceph-no-subscription.list
apt update
pveupgrade

echo "Now installing some monitoring software."

# Install some software, mostly monitoring tools. sensors and smartcl -a can provide monitoring data. lshw provides hardware info.
apt install -y screen curl htop iotop #speedtest-cli smartmontools lm-sensors lshw # sysstat # smartmontools is installed in Proxmox as a package by default.

echo "Now we need to reboot to use the new kernel."
reboot

# Download templates for Ubuntu Server 24.04.2 LTS / Proxmox Ubuntu Cloud image 24.04.2 for containers.

#echo "Now downloading the container template and VM ISO file for Ubuntu Server 24.04.2 LTS. Hit Ctrl + C to skip this and reboot manually."

#pveam update
#pveam download local ubuntu-24.04-standard_24.04-2_amd64.tar.zst # I'd actual prefer the Debian template.

# Downloads the Ubuntu Server LTS ISO for VMs. This is useful for the live OS capability, while Debian netinstall without the GUI is a lower footprint and easier network interface configuration.

#cd /var/lib/vz/template/iso/
#wget https://releases.ubuntu.com/24.04.2/ubuntu-24.04.2-live-server-amd64.iso
